// test.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "malloc.h"

wchar_t *ToWideChar(char s[])
{
	wchar_t *w = (wchar_t *)calloc(1, sizeof(wchar_t)*(strlen(s)+1));
	MultiByteToWideChar(CP_ACP, 0, s, -1, w, strlen(s));
	return w;
}

char *ToChar(const wchar_t *s)
{
	char *w = (char *)calloc(1, sizeof(char)*(wcslen(s)+1));
	WideCharToMultiByte(CP_ACP, 0, s, -1, w, wcslen(s), NULL, NULL);
	return w;
}

#include "XYDispDriver.cpp"
#include "ppl_ole.h"

BOOL end = false;

FrameSite *f;

FrameSite *_activex (HWND hWnd, wchar_t *strProgID)
{
	CLSID clsid = {0, 0, 0, {0, 0, 0, 0, 0, 0, 0, 0}}; 
	WCHAR* pProgID = (WCHAR*)strProgID;
	int hr = ::CLSIDFromProgID(pProgID, &clsid);

  FrameSite *frame = new FrameSite(hWnd);

  hr = ((IDispatch *)frame)->QueryInterface(IID_IOleClientSite, (void **)&frame->m_clientSite);

	IAdviseSink *adviseSink;
	hr = ((IDispatch *)frame)->QueryInterface(IID_IAdviseSink, (void **)&adviseSink); 

	hr = CoCreateInstance(clsid, NULL, CLSCTX_ALL, IID_IUnknown, (void **)&frame->m_ActiveX);
	hr = CoCreateInstance(clsid, NULL, CLSCTX_ALL, IID_IDispatch, (void **)&frame->m_Dispatch);

	hr = frame->m_ActiveX->QueryInterface(IID_IOleObject, (void **)&frame->m_oleObject);
	
	hr = frame->m_ActiveX->QueryInterface(IID_IViewObject, (void **)&frame->m_viewObject);

  frame->m_docAdviseCookie = 0;
  hr = frame->m_oleObject->Advise(adviseSink, &frame->m_docAdviseCookie);

	hr = frame->m_oleObject->SetHostNames(L"OLEClass", NULL);
	OleSetContainedObject(frame->m_oleObject, TRUE);
	OleRun(frame->m_oleObject);

	hr = frame->m_ActiveX->QueryInterface(IID_IOleInPlaceObject, (void **)&frame->m_oleInPlaceObject);

	DWORD dwMiscStatus;
	hr = frame->m_oleObject->GetMiscStatus(DVASPECT_CONTENT, &dwMiscStatus);

  if (dwMiscStatus & OLEMISC_SETCLIENTSITEFIRST)
		hr = frame->m_oleObject->SetClientSite(frame->m_clientSite);

	IPersistStreamInit *psi;
	hr = frame->m_oleObject->QueryInterface(IID_IPersistStreamInit, (void **)&psi);
	hr = psi->InitNew();

  if (!(dwMiscStatus & OLEMISC_SETCLIENTSITEFIRST))
		hr = frame->m_oleObject->SetClientSite(frame->m_clientSite);

	RECT posRect;
	GetWindowRect(hWnd, &posRect);

	frame->m_oleObjectHWND = NULL;
	hr = frame->m_oleInPlaceObject->GetWindow(&frame->m_oleObjectHWND);
	if (frame->m_oleObjectHWND)
		SetActiveWindow(frame->m_oleObjectHWND);

  if (!(dwMiscStatus & OLEMISC_INVISIBLEATRUNTIME))
	{
		hr = frame->m_oleInPlaceObject->SetObjectRects(&posRect, &posRect);
		hr = frame->m_oleObject->DoVerb(OLEIVERB_INPLACEACTIVATE, NULL, frame->m_clientSite, 0, hWnd, &posRect);
		hr = frame->m_oleObject->DoVerb(OLEIVERB_SHOW, 0, frame->m_clientSite, 0, hWnd, &posRect);
	}

	if (!frame->m_oleObjectHWND)
		hr = frame->m_oleInPlaceObject->GetWindow(&frame->m_oleObjectHWND);

	SetActiveWindow(frame->m_oleObjectHWND);
	ShowWindow(frame->m_oleObjectHWND, SW_SHOW);

	XYDispDriver *d = new XYDispDriver;
	d->Attach(frame->m_Dispatch);
	frame->m_com = (int)d;

	return frame;
}

void _setactivexpos (FrameSite *frame, int x, int y, int w, int h)
{
  SIZEL sz = {w, h};
	PixelsToHimetric(sz);

  SIZEL sz2;

	if (frame->m_oleObject)
	  frame->m_oleObject->GetExtent(DVASPECT_CONTENT, &sz2);
  if (sz2.cx !=  sz.cx || sz.cy != sz2.cy)
		frame->m_oleObject->SetExtent(DVASPECT_CONTENT, &sz);

	RECT posRect;
	posRect.left = x;
	posRect.top = y;
	posRect.right = w;
	posRect.bottom = h;

	if (frame->m_oleInPlaceObject)
		frame->m_oleInPlaceObject->SetObjectRects(&posRect, &posRect);
}

void _freeactivex (FrameSite *frame)
{
	if (frame->m_oleInPlaceObject)
	{
		frame->m_oleInPlaceObject->InPlaceDeactivate();
		frame->m_oleInPlaceObject->UIDeactivate();
	}

  if (frame->m_docAdviseCookie != 0)
  	frame->m_oleObject->Unadvise(frame->m_docAdviseCookie);

	if (frame->m_oleObject)
	{
		frame->m_oleObject->DoVerb(OLEIVERB_HIDE, NULL, frame->m_clientSite, 0, frame->m_hWndParent, NULL);
		frame->m_oleObject->Close(OLECLOSE_NOSAVE);
		frame->m_oleObject->SetClientSite(NULL);
	}

	if (frame->m_com)
		delete (XYDispDriver *)frame->m_com;

	delete frame;
}

void _activexdraw (FrameSite *frame)
{
	if (frame)
	{
		RedrawWindow(frame->m_oleObjectHWND, NULL, NULL, RDW_INTERNALPAINT);

		//PAINTSTRUCT ps;
		RECT posRect;
		GetClientRect(frame->m_oleObjectHWND, &posRect);

		HDC hdc = GetDC(frame->m_oleObjectHWND);
		//BeginPaint(frame->m_oleObjectHWND, &ps);

		DrawFocusRect(hdc, &posRect);

		RECTL *prcBounds = (RECTL *) &posRect;
		frame->m_viewObject->Draw(DVASPECT_CONTENT, -1, NULL, NULL, NULL, hdc, prcBounds, NULL, NULL, 0);
		//OleDraw(frame->m_ActiveX, DVASPECT_CONTENT, hdc, &posRect);
		
		//EndPaint(frame->m_oleObjectHWND, &ps);
		ReleaseDC(frame->m_oleObjectHWND, hdc);
	}
}

LRESULT CALLBACK WndProc (HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;
	
	switch (message)
	{
		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);
			if (hdc)
			{
				RECT rt;
				GetClientRect(hWnd, &rt);
				HBRUSH b = CreateSolidBrush(GetSysColor(COLOR_WINDOW));
				FillRect(hdc, &rt, b);
				DeleteObject(b);
				EndPaint(hWnd, &ps);
				//_activexdraw(f);
			}
			break;
			
		case WM_CLOSE:
			end = true;

		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
	}
		
	return 0;
}

LPWNDCLASS MyRegisterClass(char *classname, HINSTANCE hInstance)
{
	LPWNDCLASS wc;

	wc = (LPWNDCLASS)malloc(sizeof(WNDCLASS));

	wc->style = CS_HREDRAW | CS_VREDRAW;
	wc->lpfnWndProc = (WNDPROC)WndProc;
	wc->cbClsExtra = 0;
	wc->cbWndExtra = 0;
	wc->hInstance = hInstance;
	wc->hIcon = LoadIcon(hInstance, (LPCSTR)105);
	wc->hCursor = LoadCursor(NULL, IDC_ARROW);
	wc->hbrBackground = (HBRUSH)GetStockObject(COLOR_BTNFACE);
	wc->lpszMenuName = 0;
	wc->lpszClassName = classname;

	RegisterClass(wc);

	return wc;  
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	OleInitialize(NULL);

 	LPWNDCLASS wc = MyRegisterClass("TESTCLASS", hInstance);
	HWND h = CreateWindow("TESTCLASS", "MYWINDOW", WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX|WS_MAXIMIZEBOX|WS_SIZEBOX|WS_VISIBLE, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);
	ShowWindow(h, SW_SHOW);

	f = _activex(h, L"MSComctlLib.ProgCtrl.2");
	_setactivexpos(f, 10, 10, 150, 21);

	//SendMessage(f->m_oleObjectHWND, WM_USER+6, 50, 100);

	((XYDispDriver *)f->m_com)->SetProperty("Max", 100);
	((XYDispDriver *)f->m_com)->SetProperty("Value", 50);

	MSG msg;
	while (GetMessage(&msg, NULL, 0, 0) > 0)
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
		if (end)
			break;
	}

	_freeactivex(f);

	OleUninitialize();

	return 0;
}